##selection of DEG
setwd("F:\\R_Files\\GSE109651")
a=read.csv("F:GSE109651_series_matrix.txt",sep = "\t",fill = T,comment.char = "!",header = T)
rownames(a)=a[,1]
a=a[,-1]

library("hgu133plus2.db")
ids=toTable(hgu133plus2SYMBOL)
table(rownames(a) %in% ids$probe_id)
b=a[rownames(a) %in% ids$probe_id, ]
ids=ids[match(rownames(b), ids$probe_id),]

selection = function(b,ids){
  tmp = by(b,ids$symbol,
           function(x) rownames(x)[which.max(rowMeans(x))] )
  probes = as.character(tmp)
  print(dim(b))
  b=b[rownames(b) %in% probes ,]
  print(dim(b))
  rownames(b)=ids[match(rownames(b),ids$probe_id),2]
  return(b)
}
genes_exp = selection(b,ids)
genes_exp=log2(genes_exp)

library(limma)
group_list=read.csv("F:group_list.txt",sep = ",",fill = T,comment.char = "!",header = T)
rownames(group_list)=group_list[,1]
group_list=group_list[,-1]
plibcontrast.matrix = makeContrasts(paste0(unique(group_list),collapse = "-"),levels=group_list)
contrast.matrix=makeContrasts("SP-MP",levels=group_list)

fit=lmFit(genes_exp,group_list)
fit2=contrasts.fit(fit,contrast.matrix)
fit2=eBayes(fit2)
tempOutput=topTable(fit2,coef = 1,n=Inf)
nrDEG=na.omit(tempOutput)
head(nrDEG)
write.table(nrDEG,file="F:/R_Files/GSE109651/nrDEG.txt",quote=F,col.name=T,row.names=T)

DEG=nrDEG[nrDEG$logFC>2 |nrDEG$logFC< -2 ,]
DEG=DEG[DEG$P.Value< 0.05,]
DEG_up=DEG[DEG$logFC>2,]
DEG_down=DEG[DEG$logFC<0,]
DEG_exp=genes_exp[match(rownames(DEG),rownames(genes_exp)),]

write.table(DEG,file="F:/R_Files/GSE109651/DEG.txt",quote=F,col.name=T,row.names=T)
write.table(DEG_up,file="F:/R_Files/GSE109651/DEG_up.txt",quote=F,col.name=T,row.names=T)
write.table(DEG_down,file="F:/R_Files/GSE109651/DEG_down.txt",quote=F,col.name=T,row.names=T)
write.table(DEG_exp,file="F:/R_Files/GSE109651/DEG_exp.txt",quote=F,col.name=T,row.names=T)

##volcano plot
logFC_cutoff=2
nrDEG$change = as.factor(ifelse(nrDEG$P.Value < 0.05 & abs(nrDEG$logFC) > logFC_cutoff,
                                ifelse(nrDEG$logFC > logFC_cutoff ,'UP','DOWN'),'NOT'))
library(ggplot2)
ggplot(data=nrDEG, aes(x=logFC, y=-log10(P.Value), color=change))+ geom_point(alpha=0.4, size=1.75) +theme_set(theme_set(theme_bw(base_size=20)))+xlab("logFC") + ylab("-log10(p-value)") +scale_colour_manual(values = c('green','grey','red'))+geom_hline(yintercept=-log10(0.05),lty=3,lwd=1)+geom_vline(xintercept=c(-2,2),lty=3,lwd=1)+scale_y_continuous(expand = c(0,0))+theme_bw()+theme(panel.grid.major = element_blank(),panel.grid.minor = element_blank())
figure1=ggplot(data=nrDEG, aes(x=logFC, y=-log10(P.Value), color=change))+ geom_point(alpha=0.4, size=1.75) +theme_set(theme_set(theme_bw(base_size=20)))+xlab("logFC") + ylab("-log10(p-value)") +scale_colour_manual(values = c('green','grey','red'))+geom_hline(yintercept=-log10(0.05),lty=3,lwd=1)+geom_vline(xintercept=c(-2,2),lty=3,lwd=1)+scale_y_continuous(expand = c(0,0))+theme_bw()+theme(panel.grid.major = element_blank(),panel.grid.minor = element_blank())
ggsave(figure1,filename = "Figure 1.png",width = 6,height = 5)
