###GO enrichment analysis of DEGs BP/CC/MF
library(ggplot2)
library(Hmisc)
x.up=read.table("F:GO-up.txt",sep = "\t",fill = T,comment.char = "!",header = T)
x.bp1=x.up[grep("BP",x.up$Category),]
x.cc1=x.up[grep("CC",x.up$Category),]
x.mf1=x.up[grep("MF",x.up$Category),]
x.up=rbind(x.bp1,x.cc1,x.mf1)
x.up=x.up[x.up$PValue<0.05,]
x.up=x.up[,1:5]
x.up$Term=gsub(".*\\~","",x.up$Term)
x.up$Term=capitalize(x.up$Term)
x.up=x.up[order(x.up$PValue,decreasing = F),]


x.down=read.table("F:GO-down.txt",sep = "\t",fill = T,comment.char = "!",header = T)
x.bp2=x.down[grep("BP",x.down$Category),]
x.cc2=x.down[grep("CC",x.down$Category),]
x.mf2=x.down[grep("MF",x.down$Category),]
x.down=rbind(x.bp2,x.cc2,x.mf2)
x.down=x.down[x.down$PValue<0.05,]
x.down=x.down[,1:5]
x.down$Term=gsub(".*\\~","",x.down$Term)
x.down$Term=capitalize(x.down$Term)
x.down=x.down[order(x.down$PValue,decreasing = F),]

make_GO_bubble=function(go_data,term_name){
  GO_DATA=go_data[order(go_data$PValue,decreasing = F),]
  GO_DATA=head(GO_DATA,20)
  P=ggplot(GO_DATA,aes(X.,Term))
  bubble=P+geom_point(aes(size=Count,color=-log10(PValue)))
  bubble=bubble+scale_color_gradient(low="green",high="red")
  pr=bubble+theme_test(base_size = 12,base_rect_size = 1)
  pr=pr+labs(x="Gene Ratio",y=term_name)
  return(pr)
}

make_GO_bubble(x.up,term_name = "Pathway name")
make_GO_bubble(x.down,term_name = "Pathway name")
figure3.a=make_GO_bubble(x.up,term_name = "Pathway name")
figure3.b=make_GO_bubble(x.down,term_name = "Pathway name")
ggsave(figure3.a,filename = "figure 3.a.png",width=6,height = 5)
ggsave(figure3.b,filename = "figure 3.b.png",width=6,height = 5)
