library(ggplot2)
k.up=read.table("F:KEGG-up.txt",sep = "\t",fill = T,comment.char = "!",header = T)
k.up=k.up[k.up$PValue<0.05,]
k.up$change=c("Up-regulated DEGs")

k.down=read.table("F:KEGG-down.txt",sep = "\t",fill = T,comment.char = "!",header = T)
k.down=k.down[k.down$PValue<0.05,]
k.down$change=c("Down-regulated DEGs")

k=rbind(k.up,k.down)
k$PValue=-log10(k$PValue)
k=k[order(k$PValue,decreasing = F),]

##bar plot of KEGG pathway
ggplot(k,aes(x=reorder(Term,order(PValue,decreasing = F)),y=PValue,fill=change))+geom_bar(stat="identity",width=0.8,position=position_dodge(0.7))+scale_x_discrete(name="Pathway names")+scale_y_continuous(name="-log10(p-value)")+coord_flip()+theme_bw()+scale_fill_manual(values=c("cornflowerblue","brown1"))+theme_classic()


##circal plot of KEGGpathway
library(GOplot)
k_circ=rbind(k.up,k.down)
k_circ=k_circ[,1:6]
k_circ$PValue=-log10(k_circ$PValue)
k_circ=k_circ[order(k_circ$PValue,decreasing = T),]

gene_kegg=head(DEG,1000)
gene_kegg$ID=rownames(gene_kegg)
gene_kegg=gene_kegg[,c(7,1,2,3,4,5,6)]
rownames(gene_kegg)=NULL

k_circ$ID=c(substr(k_circ$Term,1,8))
k_circ$Term=gsub(".*\\:","",k_circ$Term)
k_circ=k_circ[,-(3:4)]
k_circ=k_circ[,c(1,5,2,4,3)] 
colnames(k_circ)=c("Category","ID","term","Genes","adj_pval")
circ = circle_dat(k_circ, gene_kegg)

gene_kegg=gene_kegg[order(gene_kegg$logFC),]
gene_kegg=gene_kegg[c(gene_kegg$ID%in%circ$genes),]

processgo=k_circ[,3]
processgo=k_circ[1:5,3]
chordgo = chord_dat(circ,gene_kegg,processgo)
GOChord(chordgo,space=0.02,gene.order = 'logFC',gene.space = 0.25,gene.size =2,process.label=5.5)
figure5=GOChord(chordgo,space=0.02,gene.order = 'logFC',gene.space = 0.25,gene.size =2,process.label=5.5)
ggsave(figure5,filename = "figure 5.png",width=9,height = 8)
